﻿Type=Service
Version=7.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	Public manager1 As BleManager2
	Public manager2 As BleManager2
	Public currentStateText As String = "UNKNOWN"
	Public currentState As Int
	Public ScanTimer As Timer
	
	Public m1Connected           ,m2Connected               As Boolean = False
	Public m1DevNAME             ,m2DevNAME  				As String
	Public m1DevMAC              ,m2DevMAC   				As String
	Public m1ServLIST            ,m2ServLIST 				As List
	Public m1CharLIST            ,m2CharLIST 				As Map
	Public m1FoundDevices        ,m2FoundDevices 			As List
	Public m1BleSW_Service       ,m2BleSW_Service        	As String  			
	Public m1BleSW_Characteristic,m2BleSW_Characteristic 	As String 			
	
	Type tNameAndMac (Name As String, Mac As String)
	Public PairedDevices As List
	Public ConnectedDevice As Int = -1
	
	Public nScan As Int = 0
	'Public nConnect As Int = 0
End Sub

Sub Service_Create
	manager1.Initialize("manager1")
	manager2.Initialize("manager2")
End Sub

Sub Service_Start (StartingIntent As Intent)

End Sub




'=============================================================================================================================================
'                                                                     DEVICES SCANNING
'=============================================================================================================================================

'Timer for the Scanning Timeout
Public Sub ScanTimer_Tick
	StopSCAN
End Sub


Sub Log_AdvData(Ad As Map)
Dim bc As ByteConverter
Dim data1(),data7(),data9(),data0() As Byte

	data1 = Ad.Get(1)
	data7 = Ad.Get(7)
	data9 = Ad.Get(9)
	data0 = Ad.Get(0)
	Log("     AdvMap(1): " & bc.HexFromBytes(data1))
	Log("     AdvMap(7): " & bc.HexFromBytes(data7))
	Log("     AdvMap(9): " & bc.HexFromBytes(data9) & " [" & bc.StringFromBytes(data9,"UTF-8") & "]")
	Log("     AdvMap(0): " & bc.HexFromBytes(data0))
	
End Sub

'Manager1 : Add found device into the m1FoundDevices List
Sub manager1_DeviceFound (Name As String, Id As String, AdvertisingData As Map, RSSI As Double)
Private nm As tNameAndMac	
	Log("Found: " & Name & ", " & Id & ", RSSI = " & RSSI)	' & ", " & AdvertisingData)
	nm.Name = Name
	nm.Mac  = Id
	m1FoundDevices.Add(nm)
	Log_AdvData(AdvertisingData)
End Sub

'Manager2 : Add found device to the m2FoundDevices List
Sub manager2_DeviceFound (Name As String, Id As String, AdvertisingData As Map, RSSI As Double)
Private nm As tNameAndMac	
	Log("Found: " & Name & ", " & Id & ", RSSI = " & RSSI) 	' & ", " & AdvertisingData)
	nm.Name = Name
	nm.Mac  = Id
	m2FoundDevices.Add(nm)
	Log_AdvData(AdvertisingData)
End Sub


' Stop scanning (manually or by timeout) & Connect to a device of the found devices list
Public Sub StopSCAN
	ScanTimer.Enabled = False									'Stop the Scanning Timer
	Select nScan
		Case 1
			manager1.StopScan
		Case 2
			manager2.StopScan
	End Select
End Sub




Public Sub Connect(nConnect As Int)
Private nm As tNameAndMac
Private SelectableDevices As List
Private idx As Int
	
	SelectableDevices.Initialize								'Initialize the Found Devices Listfor the GUI
	Select nConnect
		Case 1
			For i=0 To m1FoundDevices.Size-1
				nm = m1FoundDevices.Get(i)
				SelectableDevices.Add( nm.Name)
			Next
		Case 2
			For i=0 To m2FoundDevices.Size-1
				nm = m2FoundDevices.Get(i)
				SelectableDevices.Add(nm.Name)
			Next
	End Select
	
	idx = CallSub3(Main,"ConnectByList",SelectableDevices,nConnect)		'Call the GUI Pocedure "ConnectByList" to show and connect to one of the found devices
	
	Select nConnect
		Case 1
			nm = m1FoundDevices.Get(idx)
			m1DevNAME = nm.Name
			m1DevMAC = nm.Mac
			Log("Manager1 - Connecting to " & m1DevMAC)
			manager1.Connect2(m1DevMAC,False)
			
		Case 2
			nm = m2FoundDevices.Get(idx)
			m2DevNAME = nm.Name
			m2DevMAC = nm.Mac
			Log("Manager2 - Connecting to " & m2DevMAC)
			manager2.Connect2(m2DevMAC,False)
	End Select
	
End Sub


'Start Manager1 & Manager2 Scanning
Public Sub Scan
'	ScanTimer.Initialize("ScanTimer",2000)
'	ScanTimer.Enabled = False

	m1FoundDevices.Initialize
	Log(" ")
	Log("*** Manager1 Scanning")
	manager1.Scan(Null)
	Sleep(4000)
	manager1.StopScan
	
	m2FoundDevices.Initialize
	Log(" ")
	Log("*** Manager2 Scanning")
	manager2.Scan(Null)
	Sleep(4000)
	manager2.StopScan
	
	Log("Scanning End")
End Sub



'========================================================================================= GATT Data Reading
Sub manager1_DataAvailable (ServiceId As String, Characteristics As Map)
	For Each id As String In Characteristics.Keys
		m1CharLIST.Put(id,Characteristics.Get(id))
	Next
	'Log("m1CharLIST:")
	'Log(m1CharLIST)
End Sub

Sub manager2_DataAvailable (ServiceId As String, Characteristics As Map)
	For Each id As String In Characteristics.Keys
		m2CharLIST.Put(id,Characteristics.Get(id))
	Next
	'Log(Characteristics)
	'Log(m2CharLIST)
End Sub


Public Sub ReadData
	
End Sub


'========================================================================= Write into a Service Characteristic
Public Sub SendData(BytesData() As Byte,DevIdx As Int)
	Select DevIdx
		Case 1
			 manager1.WriteData(m1BleSW_Service,m1BleSW_Characteristic,BytesData)
		Case 2 
			manager2.WriteData(m2BleSW_Service,m2BleSW_Characteristic,BytesData)
	End Select
	
End Sub





'====================================================================================================================
'                                                   CONNECTION & DISCONNECTION
'====================================================================================================================
Sub manager1_StateChanged (State As Int)
	Select State
		Case manager1.STATE_POWERED_OFF
			currentStateText = "POWERED OFF"
		Case manager1.STATE_POWERED_ON
			currentStateText = "POWERED ON"
		Case manager1.STATE_UNSUPPORTED
			currentStateText = "UNSUPPORTED"
	End Select
	currentState = State
	CallSub(Main, "ShowStatus")
End Sub


Sub manager1_Disconnected
	Log("Manager1 Disconnected")
	m1Connected = False
	CallSub(Main, "ShowStatus")
End Sub

Sub manager2_Disconnected
	Log("Manager2 Disconnected")
	m2Connected = False
	CallSub(Main, "ShowStatus")
End Sub


Public Sub Disconnect
	manager1.Disconnect
	manager2.Disconnect
End Sub



Sub manager1_Connected (services As List)
Private s As String

	Log("Manager1 Connected")
	m1Connected = True
	m1ServLIST = services
	
	m1CharLIST.Initialize
	For Each s As String In m1ServLIST			'Read the Characteristics of each Found Service
		manager1.ReadData(s)
		If (s.Contains("1901")) Then
			m1BleSW_Service = s						'Identifie the UUID of the BleSW Service
			m1BleSW_Characteristic = m1BleSW_Service.Replace("1901","2031")
		Else If (s.Contains("1902")) Then
			m1BleSW_Service = s						'Identifie the UUID of the BleSW Service
			m1BleSW_Characteristic = m1BleSW_Service.Replace("1902","2031")
		End If
	Next
	Log("Service UUID = " & m1BleSW_Service)
	Log("Charact UUID = " & m1BleSW_Characteristic)
	
	CallSub(Main, "ShowStatus")
End Sub

Sub manager2_Connected (services As List)
	Log("Manager2 Connected")
	m2Connected = True
	m2ServLIST = services
	
	m2CharLIST.Initialize
	For Each s As String In m2ServLIST			'Read the Characteristics of each Found Service
		manager2.ReadData(s)
		If (s.Contains("1901")) Then
			m2BleSW_Service = s						'Identifie the UUID of the BleSW Service
			m2BleSW_Characteristic = m2BleSW_Service.Replace("1901","2031")
		Else If (s.Contains("1902")) Then
			m2BleSW_Service = s						'Identifie the UUID of the BleSW Service
			m2BleSW_Characteristic = m2BleSW_Service.Replace("1902","2031")
		End If
	Next
	Log("Service UUID = " & m2BleSW_Service)
	Log("Charact UUID = " & m2BleSW_Characteristic)
	
	CallSub(Main, "ShowStatus")
End Sub



'========================================================================================================================
'                                                             SYSTEM
'========================================================================================================================
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub
